<?php
/**
 * Chronométrage des appels php
 * @param $time
 * @param string $unit
 * @return string
 */
function eleg_microtime($time, string $unit = ''): string {
	$time = round($time, 6);

	switch ($unit) {
	case 'ms':
		return ($time*1000).' ms';
	case 'us':
	case 'µs':
		return ($time*1000000).' µs';
	case 's':
		return $time.'s';
	case '':
		return $time;
	}
	die ('mauvais parametre unit « $unit » pour eleg_microtime');
}
/** 
 * microtime_do reçoit des commandes et l'unité d'affichage 
 * @param string $command
 *      begin : reset
 *      now : microtime depuis init
 *      end : now + begin
 *      last : microtime depuis le dernier appel, sauf now
 * @param string $unit : us, ms ou s
 * @return string
 */
function microtime_do(string $command, string $unit = ''): string {
static $u_init = 0;
static $s_init = 0;
static $u_last = 0;
static $s_last = 0;
	switch ($command) {
	case 'begin':
	case 'init':
		list ($u_last, $s_last) = list ($u_init, $s_init) = explode(' ', microtime());
		return 0;

	case 'now' :
		list ($u_last, $s_last) = explode(' ', microtime()); 
		return eleg_microtime(($s_last - $s_init)+($u_last - $u_init), $unit);

	case 'end':
		list ($u_last, $s_last) = explode(' ', microtime());
		$res = ($s_last - $s_init)+($u_last - $u_init);
		$u_init = $u_last;
		$s_init = $s_last;
		return eleg_microtime($res, $unit);

	case 'last':
		list ($u_now, $s_now) = explode(' ', microtime());
		$res = ($s_now - $s_last)+($u_now - $u_last);
		$u_last = $u_now;
		$s_last = $s_now;
		return eleg_microtime($res, $unit);

	default:
		die("mauvaise commande « $command » pour microtime_do");
	}
}